
#ifndef _DISK_IDE_H
#define _DISK_IDE_H

#define DISK_HAS_48_SUPPORT	0x01
#define DISK_HAS_HPA_SUPPORT 0x02
#define DISK_HAS_REMOVABLE_SUPPORT	0x04

typedef struct {
    uint64_t native_max;    ///< the actual maximum sector
    uint64_t user_max;      ///< The maximum user sector (before HPA)
	uint8_t	flags;
    int fd;
} DISK_INFO;


DISK_INFO * device_open (int fd);
void set_max (int fd, uint64_t addr);


// from include/linux/ide.h

#ifndef IDE_COMMAND_OFFSET
#define IDE_COMMAND_OFFSET 7
#endif

#ifndef IDE_STATUS_OFFSET
#define IDE_STATUS_OFFSET 7
#endif

#ifndef IDE_SELECT_OFFSET
#define IDE_SELECT_OFFSET 6
#endif

#ifndef IDE_HCYL_OFFSET
#define IDE_HCYL_OFFSET 5
#endif

#ifndef IDE_LCYL_OFFSET
#define IDE_LCYL_OFFSET 4
#endif

#ifndef IDE_SECTOR_OFFSET
#define IDE_SECTOR_OFFSET 3
#endif

#endif
